package sorting;

public class InsertionSort implements SortingAlgorithm<Integer>
{
    /**
     * Simple insertion sort.
     * @param a an array of Comparable items.
     * @return sorting statistics.
     */
    @Override
    public Stats sort(Integer[] a)
    {
        int j;
        long totalMoves = 0;
        long totalCompares = 0;

        for (int pass = 1; pass < a.length; pass++) {
            long moves = 0;
            long compares = 0;
            Integer tmp = a[pass];
            
            for (j = pass; j > 0 && tmp.compareTo(a[j-1]) < 0; j--) {
                a[j] = a[j-1];
                moves++;
                compares++;
            }
            
            if (j > 0) compares++;
            
            if (pass != j) {
                a[j] = tmp;
                moves++;
            }
            
            totalMoves += moves;
            totalCompares += compares;
        }
        
        return new Stats(totalMoves, totalCompares);
    }

    @Override
    public Stats sort(MyLinkedList<Integer> list) { return null; };
}
